您的位置:首页 > 其它

Codeforces 478C Table Decorations【贪心】

2016-10-13 15:01 381 查看
C. Table Decorations

time limit per test
1 second

memory limit per test
256 megabytes

input
standard input

output
standard output

You have r red,
g green and b blue balloons. To decorate a single table for the banquet you need exactly three balloons. Three balloons attached to some table shouldn't have the same color. What maximum number
t of tables can be decorated if we know number of balloons of each color?

Your task is to write a program that for given values r,
g and b will find the maximum number
t of tables, that can be decorated in the required manner.

Input
The single line contains three integers r,
g and b (0 ≤ r, g, b ≤ 2·109) — the number of red, green and blue baloons respectively. The
numbers are separated by exactly one space.

Output
Print a single integer t — the maximum number of tables that can be decorated in the required manner.

Examples

Input
5 4 3


Output
4


Input
1 1 1


Output
1


Input
2 3 3


Output
2


Note
In the first sample you can decorate the tables with the following balloon sets: "rgg", "gbb", "brr", "rrg",
where "r", "g" and "b" represent the red, green and blue balls, respectively.

题目大意:

一共三种颜色的气球,每种气球的个数已知,对应有一排桌子,我们需要对每一个桌子分配三个气球,但是一个桌子上的气球的颜色不能相同,问最多能够分配多少个桌子。

思路:

1、显然利用到贪心思想,每一次选取最多的颜色气球两个,加上最少的颜色的气球一个,分配到一个桌子上,但是因为数据很大,直接模拟一定会超时,那么考虑枚举找规律。

2、

①那么显然,如果最少数量的两个颜色的气球的数量总和乘以2如果小于等于另外颜色的气球的个数,显然答案是最少数量的两个颜色的气球个数和。

②其他情况经过枚举发现,因为我们在模拟过程中三种颜色的气球时大时小,其实一直模拟下去的解就是三种颜色的气球的总和/3.

Ac代码:

#include<stdio.h>
#include<string.h>
#include<algorithm>
using namespace std;
#define ll __int64int main()
{
ll aa,bb,cc;
while(~scanf("%I64d%I64d%I64d",&aa,&bb,&cc))
{
ll a[5];
a[0]=aa;
a[1]=bb;
a[2]=cc;
sort(a出,a+3);
if(a[0]*2+a[1]*2<=a[2])
printf("%I64d",a[0]+a[1]);
else printf("%I64d\n",(a[0]+a[1]+a[2])/3);
}
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  Codeforces 478C